/* TCPhello1.c - main(), connectTCPsock(),  TCPhello()*/

#include <arpa/inet.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#define LINELEN 128

int connectTCPsock(const char *host, const char *service);
int	TCPhello(const int);

/*------------------------------------------------------------------------
 * main - TCP client for Hello World!
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{ 
    const char *host = "127.0.0.1"; /* server ip addrss */
	const char *service = "5678"; /* service port */
    int clientsocket; /* client socket descriptor */

    /* 与TCPhello服务器建立连接并得到业已 *
     * 连接的套接字（clientsocket） */
    clientsocket = connectTCPsock(host, service);

    /* 在业已连接的套接字（clientsocket）上   *
     * 接收来自hello服务器的回复并进行响应处理 */
    TCPhello(clientsocket); 

	exit(0);
}

int
connectTCPsock(const char *host, const char *service)
{
    struct sockaddr_in servsa; /* server Inernet endpoint address */
    int connsd; /* connect socket descriptor */

    /* initialize sockaddr_in structure */
    memset(&servsa, 0, sizeof servsa);
    servsa.sin_family = AF_INET;
    /* servsa.sin_addr.s_addr = inet_addr(host); obsolete */
    inet_pton(AF_INET, host, &servsa.sin_addr.s_addr);    
    servsa.sin_port = htons((uint16_t)atoi(service));

    /* create a socket */
    connsd = socket(PF_INET, SOCK_STREAM, 0);
  
    /* connect the socket */
    connect(connsd, (struct sockaddr *)&servsa, sizeof servsa);
    
    return connsd;
}

int
TCPhello(const int tsockd)
{   /* receive the reply and handle the response */

	char buf[LINELEN+1]; /* buffer for one line of text */
	ssize_t	nchars; /* receive count */

	/* receive the reply */
    while((nchars = recv(tsockd, buf, LINELEN, 0)) > 0) { 
        /* handle the response  */
        buf[nchars] = '\0'; /* ensure null-terminated */
		fputs(buf, stdout);
	}
    
    return 0;
}

/*************************************************************************
 * To compile:                                                         
gcc -Wall -pedantic -std=c11 -g -o ../../apps/TCPhello.exe TCPhello.c                             *
 * To run:                                                               *
 * ../../apps/TCPhello.exe                                               *
 *                                                                       *
 *************************************************************************/
