/* TCPhello3.c - main */
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <err.h>

#define	LINELEN 128

int	connectTCPsock(const char *host, const char *service);
int	TCPhello(const int);

/*------------------------------------------------------------------------
 * main - TCP(IPv6) client for Hello World!
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{
    const char *host = "fe80::4d1:6d3e:b9a4:adbf"; /* host to use if none supplied   ::1
    本地链接 IPv6 地址:	fe80::4d1:6d3e:b9a4:adbf%6*/
	const char *service = "5678"; /* default service port */
    int clientsocket; /* client socket descriptor */

    /* 与TCPhello服务器建立连接并得到业已 *
     * 连接的套接字（clientsocket）      */
    clientsocket = connectTCPsock(host, service);

    /* 在业已连接的套接字（clientsocket）上 *
     * 接收来自hello服务器的回复并进行响应处理  */
    (void) TCPhello(clientsocket); 

	exit(0);
}

int
connectTCPsock(const char *host, const char *service)
{
    struct sockaddr_in6 servsa; /* server Inernet endpoint address */
    int connsd; /* connect socket descriptor */

    /* initialize sockaddr_in6 structure */
    memset(&servsa, 0, sizeof servsa);
    servsa.sin6_family = AF_INET6;

    inet_pton(AF_INET6, host, &servsa.sin6_addr.s6_addr);

    servsa.sin6_port = htons((uint16_t)atoi(service));

    /* create a socket */
    connsd = socket(PF_INET6, SOCK_STREAM, 0);
  
    /* connect the socket */
    connect(connsd, (struct sockaddr *)&servsa, sizeof servsa);
    
    return connsd;
}

int
TCPhello(const int tsockd)
{   /* receive the reply and handle the response */
	char buf[LINELEN+1]; /* buffer for one line of text */
	ssize_t	nchars; /* receive count */

	/* receive the reply */
    while((nchars = recv(tsockd, buf, LINELEN, 0))) {
        /* handle the response  */
        buf[nchars] = '\0'; /* ensure null-terminated */
		fputs(buf, stdout);
	}
  
    return 0;
}

/*************************************************************************
 * To compile:                                                           *
 * gcc -Wall -pedantic -std=c11 -g                                       *
 *     -o ../../apps/TCPipv6hello.exe TCPipv6hello.c                     *
 * To run:                                                               *
 * ../apps/../TCPipv6hello.exe                                           *
 *                                                                       *
 *************************************************************************/