/* UDPhello1.c - main */

#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#define	LINELEN 128

int	connectUDPsock(const char *host, const char *service);
int	UDPhello(const int);

/*------------------------------------------------------------------------
 * main - UDP client for Hello World!
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{ 
    const char *host = "127.0.0.1"; /* server ip addrss */
	const char *service = "5678"; /* service port */
    int clientsocket; /* connected UDP socket descriptor */

    /* 创建客户套接字（clientsocket）并使其成为连接的UDP套接字 */
    clientsocket = connectUDPsock(host, service);
    
    /* 发送请求并接收来自UDPhello服务器的回复并进行响应处理 */
    UDPhello(clientsocket); 

	exit(0);
}

int
connectUDPsock(const char *host, const char *service)
{
    struct sockaddr_in servsa; /* server Inernet endpoint address */
    int connsd; /* connect socket descriptor */

    /* initialize sockaddr_in structure */
    memset(&servsa, 0, sizeof servsa);
    servsa.sin_family = AF_INET;
    /* servsa.sin_addr.s_addr = inet_addr(host); obsolete */
    inet_pton(AF_INET, host, &servsa.sin_addr.s_addr);
    servsa.sin_port = htons((uint16_t)atoi(service));

    /* create a socket */
    connsd = socket(PF_INET, SOCK_DGRAM, 0);

    /* connect the socket */
    connect(connsd, (struct sockaddr *)&servsa, sizeof servsa);

    return connsd;
}

int
UDPhello(const int usockd)
{   /* receive the reply and handle the response */
	char request[] = "Hey are you there?\n";
    char buf[LINELEN+1]; /* buffer for one line of text */
    ssize_t nchars; /* receive count */

	/* send the request */
	(void) send(usockd, request, strlen(request), 0);

	/* receive the reply */		
	nchars = recv(usockd, buf, sizeof buf, 0);

    /* handle the response */
    buf[nchars] = '\0'; /* ensure null-terminated */
	fputs(buf, stdout);
    
    return 0;
}

/*************************************************************************
 * To compile:                                                           *
 * gcc -Wall -pedantic -std=c11 -g                                       *
 *     -o ../../apps/UDPhello.exe UDPhello.c                             *
 * To run:                                                               *
 * ../../apps/UDPhello.exe                                               *
 *                                                                       *
 *************************************************************************/