/* UDPhellod1.c - main */

#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

int passiveUDPsock(const char *);
int UDPhellod(const int);

/*------------------------------------------------------------------------
 * main - Iterative UDP server for Hello World!
 *------------------------------------------------------------------------
 */
int
main(int argc, char *argv[])
{
	const char *service = "5678"; /* service port number	*/
    int servsockd;    /* server socket descriptor */
    
    /* 创建hello服务器（UDP）套接字（servsockd） */
    servsockd = passiveUDPsock(service);
    
    /* 迭代 */
	while (1) {
        /* 接收请求并进行处理，构造并发送应答 */
        UDPhellod(servsockd);
	}
}

int
passiveUDPsock(const char *service)
{
    struct sockaddr_in sin; /* an Inernet endpoint address */
	int pasvsd; /* passive socket descriptor */

    /* initialize sockaddr_in structure */
    memset(&sin, 0, sizeof sin);
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr = INADDR_ANY;
    sin.sin_port = htons((uint16_t)atoi(service));

    /* create a socket */
    pasvsd = socket(PF_INET, SOCK_DGRAM, 0);

    /* bind the socket */
    bind(pasvsd, (struct sockaddr *)&sin, sizeof sin);

    return pasvsd;
}

int UDPhellod(const int usockd)
{
    char replymsg[] = "Hello World!\n";
    struct sockaddr_in fsa; /* the from socket address of a client */
	socklen_t salen; /* from-address length */
    char buf[1]; /* "input" buffer; any size > 0 */
    char fmtddr[128]; /* the formated address string */

	salen = sizeof fsa;
    /* receive next request */
    recvfrom(usockd, buf, sizeof buf, 0, (struct sockaddr *)&fsa, &salen);		  

    inet_ntop(AF_INET, &fsa.sin_addr.s_addr, fmtddr, sizeof fmtddr);
    printf("data from %s:%d\n", fmtddr, ntohs(fsa.sin_port));

    /* handle the request, formulate a reply *
     * send the reply                        */
    sendto(usockd, replymsg, strlen(replymsg), 0, 
            (struct sockaddr *)&fsa, salen); 

    return 0;
}

/*************************************************************************
 * To compile:                                                           *
 * gcc -Wall -pedantic -std=c11 -g                                       *
 *     -o ../../apps/UDPhellod.exe UDPhellod.c                           *
 * To run:                                                               *
 * ../../apps/UDPhellod.exe                                              *
 *                                                                       *
 *************************************************************************/